<?php

namespace common\modules\triggers\controllers;

use common\components\BaseController;
use common\modules\bids\models\Bid;
use common\modules\content\models\CoContent;
use common\modules\messageTemplate\models\MessageTemplate;
use common\modules\triggers\components\conditions\Conditions;
use common\modules\triggers\models\AuthHashes;
use common\modules\triggers\models\CasesSchedule;
use common\modules\triggers\models\TriggerLogs;
use common\modules\triggers\models\TriggerSchedule;
use common\modules\triggers\models\TriggerTrigger;
use common\modules\users\models\User;
use \DateTime;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use common\modules\messageTemplate\components\Templates;
use common\components\UnisenderAPI;

/**
 * Default controller for the `triggers` module
 */
class DefaultController extends BaseController
{
    public static function actionsTitles(){
        return [
            'Index' => 'Главная страница модуля',
            'Rechecktriggers' => 'Запуск проверки срабатывания триггеров',
            'Recheckcases' => 'Запуск рассылки кейсов',
            'Settimeoflogs' => 'Фиксация времени логов',
            'Inittrigger' => 'Initiate trigger By id',
            'Sendcases' => 'Send cases by schedule'
        ];
    }

    /**
     * @param $id
     * @param $value
     */
    public function actionSettimeoflogs($id, $value)
    {
        /** @var TriggerLogs $model */
        $model = TriggerLogs::findOne($id);
        if (!is_null($model)) {
            $model->presence_time = $value;
            $model->save(false);
        }
    }

    public function actionInittrigger($id){
        if (\Yii::$app->request->isAjax) {
            /** @var TriggerTrigger $trigger */
            $trigger = TriggerTrigger::findOne($id);
            $trigger->initAction();
        }
    }

    /**
     * Renders the index view for the module
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Метод для крона и ручного вызова. Проверяет таблицу с расписанием, выполняет сработавшие триггеры.
     */
    public function actionRechecktriggers(){
        set_time_limit(5000);
        // Производим проверку по расписанию
        /** @var TriggerTrigger[] $actualTriggers */
        // Получили текущую дату и время
        $timeNow = new DateTime();
        // Получили все те сообщения которые еще не обработаны и имеют дату равную или меньше текущей
        /** @var TriggerSchedule[] $uncheckedArray */
        $uncheckedArray = TriggerSchedule::find()->where('time <= :time_now', [':time_now' => $timeNow->format('Y-m-d H:i:s')])->all();
        // Получили все актуальные триггеры в базе
        $actualTriggers = TriggerTrigger::getActualTriggers();
        // Перебираем эти сообщения в цикле
        foreach($uncheckedArray as $message) {
            $triggerIsUsed=false;
            // Проверяем каждое сообщение на срабатывание триггера
            foreach($actualTriggers as $trigger) {
                // Вызвали метод проверки срабатывания условий
                $triggerResult = Conditions::init()->handleMessageByTriggerId($message, $trigger->getPrimaryKey());
                // Если триггер сработал инициируем действие
                if ($triggerResult===true) {
                    $triggerIsUsed=true;
                    $init = $trigger->initAction(['email' => $message->email]);
                    if ($init!==true)
                        echo $init;
                }
            }
            if ($triggerIsUsed===true) {
                /** @var TriggerSchedule $model */
                $model=TriggerSchedule::findOne($message->getPrimaryKey());
                $model->checked=1;
                $model->save();
            }
        }

        // Производим проверку событий
        $users = User::find()->where('id>0')->all();
        foreach($users as $user) {
            foreach($actualTriggers as $trigger) {
                // Вызвали метод проверки срабатывания условий
                $triggerResult = Conditions::init()->handleUserByTriggerId($user->getPrimaryKey(), $trigger->getPrimaryKey());
                // Если триггер сработал инициируем действие
                if ($triggerResult===true) {
                    $init = $trigger->initAction(['email' => $user->email]);
                    if ($init!==true)
                        echo $init;
                }
            }
        }
    }

    /**
     * Вызов логики отвечающей за заполнение расписания рассылок по кейсам.
     * Заполняет таблицу с предстоящими рассылками для дальнейшей обработки.
     *
     * @param int $category_id
     */
    public function actionRecheckcases($category_id = 4) {
        /** @var User[] $users */
        $users = User::find()->all();
        // Получили массив case-ов
        /** @var CoContent[] $cases */
        $cases = CoContent::find()->where(['category_id'=>$category_id])->all();
        // Перемешали массив case в случайном порядке
        shuffle($cases);
        // Перебираем в цикле пользователей
        foreach($users as $user) {
            // Если пользователь подписан
            if (Bid::find()->where(['email' => $user->email])->exists()) {
                // Перебираем все case-ы
                foreach($cases as $case) {
                    // Проверили наличие отправки кейса юзеру
                    $scheduleExist = CasesSchedule::find()->where(['case_id' => $case->id, 'user_id' => $user->id])->exists();
                    // Если отправка в расписании отсутствует
                    if (!$scheduleExist) {
                        // Заносим в расписание
                        $model = new CasesSchedule();
                        $model->user_id = $user->id;
                        $model->case_id = $case->id;
                        $model->template_id = (!is_null($case->template_id)) ? $case->template_id : null;
                        $model->sended_date = null;
                        $model->sended = 0;
                        $model->actual = 1;
                        if (!$model->save())
                            echo current(current($model->getErrors())).'<br>';
                    }
                }
            }
        }
    }

    /**
     * Метод производит рассылку по расписанию
     *
     * @param int $neededTime
     */
    public function actionSendcases($neededTime=10) {
        $date = new \DateTime();
        /** @var User[] $users */
        $users = User::find()->all();
        // URL основной страницы
        $baseUrl = 'http://task-on.com/';
        // Получили все данные в расписании
        /** @var CasesSchedule[] $schedule */
        $schedule = CasesSchedule::find()->where(['sended' => 0])->all();
        // Перебираем в цикле пользователей
        foreach($users as $user) {
            // Определили отправленность сообщения
            $sendedToUser=false;
            // Получили дату для дальнейшего сравнения
            $deliveryDate = new \DateTime($user->delivery_date);
            // Если пользователь подписан и дата соответствует требованиям
            if (Bid::find()->where(['email' => $user->email])->exists() && $deliveryDate<=$date) {
                // Перебираем все записи
                foreach($schedule as $record) {
                    // Если ни одно письмо еще не отправлено
                    if ($sendedToUser===false) {
                        // Получили кейс
                        /** @var CoContent $case */
                        $case = $record->case;
                        // Если кейс есть и у него есть шаблон
                        if (!is_null($case) && (!is_null($case->template_id) || !is_null($record->template_id))) {
                            $template_id = (!is_null($case->template_id)) ? $case->template_id : $record->template_id;
                            // Заносим урл в переменную
                            $url = $case->url;
                            // Получаем время просмотра каждой страницы
                            $watchingtime = TriggerLogs::getSummaryTimeByUrl($url, $user->id);
                            // Если суммарное время просмотра меньше минимальной нормы (то есть кейс еще не просмотрен)
                            if ((int)$watchingtime<(int)$neededTime) {
                                echo "ASD"; die;
                                // Производим отправку письма
                                // Получаем почту
                                $email = $user->email;
                                // Генерируем хеш
                                $hash=AuthHashes::setNewHash($email);
                                // Сформировали дату
                                $templateData = [
                                    'case_link' => $baseUrl.$url.'?hash='.$hash.'&email='.$email
                                ];
                                // Производим отправку
                                /** @var \DateTime $time_now */
                                TriggerSchedule::sendMessage($email, $template_id, $templateData, null);
                                // Произвели отправку, следовательно переопределили значение переменной
                                $sendedToUser=true;
                                // Редактируем запись в расписании
                                /** @var CasesSchedule $model */
                                $model = CasesSchedule::findOne($record->id);
                                $model->sended_date = $date->format('Y-m-d H:i:s');
                                $model->sended = 1;
                                $model->save();
                            }
                        }
                    }
                }
                // Создали дату следующей отправки
                $updatedDate=new \DateTime();
                // Произвели модификацию даты
                $updatedDate->modify('+7 days');
                /** @var User $user */
                // Нашли пользователя
                $user=User::findOne($user->id);
                // Переопределили поле
                $user->delivery_date = $updatedDate->format('Y-m-d');
                // Сохранили изменения
                $user->save(false);
            }
        }
    }
}
